# -------------------------------------------------------------------------------------------------
#<profile4xi profile = "11" /> 
#<program4xi program = "zapimport2ball4xi.py">
#<abstract4xi abstract = "Imports selected zap Python modules created by multiprocessing4xi"/>
#<verify4xi verification = "11" target = "actor4xi.py"/>
#<contextualize4xi context = "Zap source programs"/> 
#<use4xi usage = "
# SET:
#   ZapKb4Xi <-- mark the one to be imported
#
# RUN:
# > python zapimport2ball4xi.py > E:\scope4xi\041721\zap\work\txt\zapimport2ball4xi.txt
# warning:  DO NOT TRY TO RUN TOO MANY IN THE SAME RUN - ONE RECOMMENDED!
# remember: you need to have ALL the latest xml-files created & scoped & zapped!
#
# ANALYZE:
# use Studio4Xi to find bugs!
# sense-test-zskeleton4xi.html       <-- example HTML file generated (depends on input selected), view source in browser!
# sense-zapimport2ball4xi.xml        <-- trace in XML
# reason-zapimport2ball4xi.xml       <-- trace in XML
# ace-zapimport2ball4xi.xml          <-- trace in XML
# zapimport2ball4xi.txt              <-- OF ZAPIMPORT2BALL4XI
#"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['zapimport2ball4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# ScopeXi Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global PickleKB4Xi
global t2xi 
global ZapKb4Xi
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging  
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from import2ball4xi import import2ball4xi
from yoke4xi import yoke4xi
#"
#/>


# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi 
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi

from print4xi import Print4Xi

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi


# -------------------------------------------------------------------------------------------------
# Zap imports                      
# -------------------------------------------------------------------------------------------------
from ace_all_methods4xi_zap import SphereKB4Xi as ace_all_methods4xi_zap2sphere
from ace_ctypes4xi_zap import SphereKB4Xi as ace_ctypes4xi_zap2sphere
from ace_current_process4xi_zap import SphereKB4Xi as ace_current_process4xi_zap2sphere
from ace_dummy_process4xi_zap import SphereKB4Xi as ace_dummy_process4xi_zap2sphere
from ace_finalize4xi_zap import SphereKB4Xi as ace_finalize4xi_zap2sphere
from ace_hello_pipe4xi_zap import SphereKB4Xi as ace_hello_pipe4xi_zap2sphere
from ace_hello_world4xi_zap import SphereKB4Xi as ace_hello_world4xi_zap2sphere
from ace_math4xi_zap import SphereKB4Xi as ace_math4xi_zap2sphere
from ace_pickle4xi_zap import SphereKB4Xi as ace_pickle4xi_zap2sphere
from ace_pipe1_test4xi_zap import SphereKB4Xi as ace_pipe1_test4xi_zap2sphere
from ace_pool_one_4xi_zap import SphereKB4Xi as ace_pool_one_4xi_zap2sphere
from ace_processref4xi_zap import SphereKB4Xi as ace_processref4xi_zap2sphere
from ace_proxy_mp_test4xi_zap import SphereKB4Xi as ace_proxy_mp_test4xi_zap2sphere
from ace_public_methods_test4xi_zap import SphereKB4Xi as ace_public_methods_test4xi_zap2sphere
from ace_sync_manager_test4xi_zap import SphereKB4Xi as ace_sync_manager_test4xi_zap2sphere
from ace_test_after_fork4xi_zap import SphereKB4Xi as ace_test_after_fork4xi_zap2sphere
from ace_test_arena4xi_zap import SphereKB4Xi as ace_test_arena4xi_zap2sphere
from ace_test_constant_connection4xi_zap import SphereKB4Xi as ace_test_constant_connection4xi_zap2sphere
from ace_test_constant_family4xi_zap import SphereKB4Xi as ace_test_constant_family4xi_zap2sphere
from ace_test_constant_forking4xi_zap import SphereKB4Xi as ace_test_constant_forking4xi_zap2sphere
from ace_test_constant_heap4xi_zap import SphereKB4Xi as ace_test_constant_heap4xi_zap2sphere
from ace_test_constant_logger4xi_zap import SphereKB4Xi as ace_test_constant_logger4xi_zap2sphere
from ace_test_constant_managers4xi_zap import SphereKB4Xi as ace_test_constant_managers4xi_zap2sphere
from ace_test_constant_pool4xi_zap import SphereKB4Xi as ace_test_constant_pool4xi_zap2sphere
from ace_test_constant_process4xi_zap import SphereKB4Xi as ace_test_constant_process4xi_zap2sphere
from ace_test_constant_synchronize4xi_zap import SphereKB4Xi as ace_test_constant_synchronize4xi_zap2sphere
from ace_test_constant_system4xi_zap import SphereKB4Xi as ace_test_constant_system4xi_zap2sphere
from ace_test_constant_util4xi_zap import SphereKB4Xi as ace_test_constant_util4xi_zap2sphere
from ace_test_cpu_corecount4xi_zap import SphereKB4Xi as ace_test_cpu_corecount4xi_zap2sphere
from ace_test_format4xi_zap import SphereKB4Xi as ace_test_format4xi_zap2sphere
from ace_test_kskeleton4xi_zap import SphereKB4Xi as ace_test_kskeleton4xi_zap2sphere
from ace_test_logger4xi_zap import SphereKB4Xi as ace_test_logger4xi_zap2sphere
from ace_test_manager4xi_zap import SphereKB4Xi as ace_test_manager4xi_zap2sphere
from ace_test_original_dir4xi_zap import SphereKB4Xi as ace_test_original_dir4xi_zap2sphere
from ace_test_server4xi_zap import SphereKB4Xi as ace_test_server4xi_zap2sphere
from ace_test_shared_ctypes4xi_zap import SphereKB4Xi as ace_test_shared_ctypes4xi_zap2sphere
from ace_test_skeleton_print4xi_zap import SphereKB4Xi as ace_test_skeleton_print4xi_zap2sphere
from ace_test_sphere4xi_zap import SphereKB4Xi as ace_test_sphere4xi_zap2sphere
from ace_test_state4xi_zap import SphereKB4Xi as ace_test_state4xi_zap2sphere
from ace_test_uskeleton4xi_zap import SphereKB4Xi as ace_test_uskeleton4xi_zap2sphere
from ace_test_yskeleton4xi_zap import SphereKB4Xi as ace_test_yskeleton4xi_zap2sphere
from ace_test_zskeleton4xi_zap import SphereKB4Xi as ace_test_zskeleton4xi_zap2sphere
from ace_value_proxy4xi_zap import SphereKB4Xi as ace_value_proxy4xi_zap2sphere
from ace_value_test4xi_zap import SphereKB4Xi as ace_value_test4xi_zap2sphere
    
from reason_all_methods4xi_zap import SphereKB4Xi as reason_all_methods4xi_zap2sphere
from reason_ctypes4xi_zap import SphereKB4Xi as reason_ctypes4xi_zap2sphere
from reason_current_process4xi_zap import SphereKB4Xi as reason_current_process4xi_zap2sphere
from reason_dummy_process4xi_zap import SphereKB4Xi as reason_dummy_process4xi_zap2sphere
from reason_finalize4xi_zap import SphereKB4Xi as reason_finalize4xi_zap2sphere
from reason_hello_pipe4xi_zap import SphereKB4Xi as reason_hello_pipe4xi_zap2sphere
from reason_hello_world4xi_zap import SphereKB4Xi as reason_hello_world4xi_zap2sphere
from reason_math4xi_zap import SphereKB4Xi as reason_math4xi_zap2sphere
from reason_pickle4xi_zap import SphereKB4Xi as reason_pickle4xi_zap2sphere
from reason_pipe1_test4xi_zap import SphereKB4Xi as reason_pipe1_test4xi_zap2sphere
from reason_pool_one_4xi_zap import SphereKB4Xi as reason_pool_one_4xi_zap2sphere
from reason_processref4xi_zap import SphereKB4Xi as reason_processref4xi_zap2sphere
from reason_proxy_mp_test4xi_zap import SphereKB4Xi as reason_proxy_mp_test4xi_zap2sphere
from reason_public_methods_test4xi_zap import SphereKB4Xi as reason_public_methods_test4xi_zap2sphere
from reason_sync_manager_test4xi_zap import SphereKB4Xi as reason_sync_manager_test4xi_zap2sphere
from reason_test_after_fork4xi_zap import SphereKB4Xi as reason_test_after_fork4xi_zap2sphere
from reason_test_arena4xi_zap import SphereKB4Xi as reason_test_arena4xi_zap2sphere
from reason_test_constant_connection4xi_zap import SphereKB4Xi as reason_test_constant_connection4xi_zap2sphere
from reason_test_constant_family4xi_zap import SphereKB4Xi as reason_test_constant_family4xi_zap2sphere
from reason_test_constant_forking4xi_zap import SphereKB4Xi as reason_test_constant_forking4xi_zap2sphere
from reason_test_constant_heap4xi_zap import SphereKB4Xi as reason_test_constant_heap4xi_zap2sphere
from reason_test_constant_logger4xi_zap import SphereKB4Xi as reason_test_constant_logger4xi_zap2sphere
from reason_test_constant_managers4xi_zap import SphereKB4Xi as reason_test_constant_managers4xi_zap2sphere
from reason_test_constant_pool4xi_zap import SphereKB4Xi as reason_test_constant_pool4xi_zap2sphere
from reason_test_constant_process4xi_zap import SphereKB4Xi as reason_test_constant_process4xi_zap2sphere
from reason_test_constant_synchronize4xi_zap import SphereKB4Xi as reason_test_constant_synchronize4xi_zap2sphere
from reason_test_constant_system4xi_zap import SphereKB4Xi as reason_test_constant_system4xi_zap2sphere
from reason_test_constant_util4xi_zap import SphereKB4Xi as reason_test_constant_util4xi_zap2sphere
from reason_test_cpu_corecount4xi_zap import SphereKB4Xi as reason_test_cpu_corecount4xi_zap2sphere
from reason_test_format4xi_zap import SphereKB4Xi as reason_test_format4xi_zap2sphere
from reason_test_kskeleton4xi_zap import SphereKB4Xi as reason_test_kskeleton4xi_zap2sphere
from reason_test_logger4xi_zap import SphereKB4Xi as reason_test_logger4xi_zap2sphere
from reason_test_manager4xi_zap import SphereKB4Xi as reason_test_manager4xi_zap2sphere
from reason_test_original_dir4xi_zap import SphereKB4Xi as reason_test_original_dir4xi_zap2sphere
from reason_test_server4xi_zap import SphereKB4Xi as reason_test_server4xi_zap2sphere
from reason_test_shared_ctypes4xi_zap import SphereKB4Xi as reason_test_shared_ctypes4xi_zap2sphere
from reason_test_skeleton_print4xi_zap import SphereKB4Xi as reason_test_skeleton_print4xi_zap2sphere
from reason_test_sphere4xi_zap import SphereKB4Xi as reason_test_sphere4xi_zap2sphere
from reason_test_state4xi_zap import SphereKB4Xi as reason_test_state4xi_zap2sphere
from reason_test_uskeleton4xi_zap import SphereKB4Xi as reason_test_uskeleton4xi_zap2sphere
from reason_test_yskeleton4xi_zap import SphereKB4Xi as reason_test_yskeleton4xi_zap2sphere
from reason_test_zskeleton4xi_zap import SphereKB4Xi as reason_test_zskeleton4xi_zap2sphere
from reason_value_proxy4xi_zap import SphereKB4Xi as reason_value_proxy4xi_zap2sphere
from reason_value_test4xi_zap import SphereKB4Xi as reason_value_test4xi_zap2sphere

from sense_all_methods4xi_zap import SphereKB4Xi as sense_all_methods4xi_zap2sphere
from sense_ctypes4xi_zap import SphereKB4Xi as sense_ctypes4xi_zap2sphere
from sense_current_process4xi_zap import SphereKB4Xi as sense_current_process4xi_zap2sphere
from sense_dummy_process4xi_zap import SphereKB4Xi as sense_dummy_process4xi_zap2sphere
from sense_finalize4xi_zap import SphereKB4Xi as sense_finalize4xi_zap2sphere
from sense_hello_pipe4xi_zap import SphereKB4Xi as sense_hello_pipe4xi_zap2sphere
from sense_hello_world4xi_zap import SphereKB4Xi as sense_hello_world4xi_zap2sphere
from sense_math4xi_zap import SphereKB4Xi as sense_math4xi_zap2sphere
from sense_pickle4xi_zap import SphereKB4Xi as sense_pickle4xi_zap2sphere
from sense_pipe1_test4xi_zap import SphereKB4Xi as sense_pipe1_test4xi_zap2sphere
from sense_pool_one_4xi_zap import SphereKB4Xi as sense_pool_one_4xi_zap2sphere
from sense_processref4xi_zap import SphereKB4Xi as sense_processref4xi_zap2sphere
from sense_proxy_mp_test4xi_zap import SphereKB4Xi as sense_proxy_mp_test4xi_zap2sphere
from sense_public_methods_test4xi_zap import SphereKB4Xi as sense_public_methods_test4xi_zap2sphere
from sense_sync_manager_test4xi_zap import SphereKB4Xi as sense_sync_manager_test4xi_zap2sphere
from sense_test_after_fork4xi_zap import SphereKB4Xi as sense_test_after_fork4xi_zap2sphere
from sense_test_arena4xi_zap import SphereKB4Xi as sense_test_arena4xi_zap2sphere
from sense_test_constant_connection4xi_zap import SphereKB4Xi as sense_test_constant_connection4xi_zap2sphere
from sense_test_constant_family4xi_zap import SphereKB4Xi as sense_test_constant_family4xi_zap2sphere
from sense_test_constant_forking4xi_zap import SphereKB4Xi as sense_test_constant_forking4xi_zap2sphere
from sense_test_constant_heap4xi_zap import SphereKB4Xi as sense_test_constant_heap4xi_zap2sphere
from sense_test_constant_logger4xi_zap import SphereKB4Xi as sense_test_constant_logger4xi_zap2sphere
from sense_test_constant_managers4xi_zap import SphereKB4Xi as sense_test_constant_managers4xi_zap2sphere
from sense_test_constant_pool4xi_zap import SphereKB4Xi as sense_test_constant_pool4xi_zap2sphere
from sense_test_constant_process4xi_zap import SphereKB4Xi as sense_test_constant_process4xi_zap2sphere
from sense_test_constant_synchronize4xi_zap import SphereKB4Xi as sense_test_constant_synchronize4xi_zap2sphere
from sense_test_constant_system4xi_zap import SphereKB4Xi as sense_test_constant_system4xi_zap2sphere
from sense_test_constant_util4xi_zap import SphereKB4Xi as sense_test_constant_util4xi_zap2sphere
from sense_test_cpu_corecount4xi_zap import SphereKB4Xi as sense_test_cpu_corecount4xi_zap2sphere
from sense_test_format4xi_zap import SphereKB4Xi as sense_test_format4xi_zap2sphere
from sense_test_kskeleton4xi_zap import SphereKB4Xi as sense_test_kskeleton4xi_zap2sphere
from sense_test_logger4xi_zap import SphereKB4Xi as sense_test_logger4xi_zap2sphere
from sense_test_manager4xi_zap import SphereKB4Xi as sense_test_manager4xi_zap2sphere
from sense_test_original_dir4xi_zap import SphereKB4Xi as sense_test_original_dir4xi_zap2sphere
from sense_test_server4xi_zap import SphereKB4Xi as sense_test_server4xi_zap2sphere
from sense_test_shared_ctypes4xi_zap import SphereKB4Xi as sense_test_shared_ctypes4xi_zap2sphere
from sense_test_skeleton_print4xi_zap import SphereKB4Xi as sense_test_skeleton_print4xi_zap2sphere
from sense_test_sphere4xi_zap import SphereKB4Xi as sense_test_sphere4xi_zap2sphere
from sense_test_state4xi_zap import SphereKB4Xi as sense_test_state4xi_zap2sphere
from sense_test_uskeleton4xi_zap import SphereKB4Xi as sense_test_uskeleton4xi_zap2sphere
from sense_test_yskeleton4xi_zap import SphereKB4Xi as sense_test_yskeleton4xi_zap2sphere
from sense_test_zskeleton4xi_zap import SphereKB4Xi as sense_test_zskeleton4xi_zap2sphere
from sense_value_proxy4xi_zap import SphereKB4Xi as sense_value_proxy4xi_zap2sphere
from sense_value_test4xi_zap import SphereKB4Xi as sense_value_test4xi_zap2sphere        



#"
#/>



# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi}
       
t2xi = Print4Xi()

# ---------------------------------------------------------------------------------------------
# WARNING:  DO NOT TRY TO RUN TOO MANY IN THE SAME RUN - MIGHT REQUIRE TOO MUCH MEMORY !
#     TIP:  OPEN THREE (3) WINDOWS AND IMPORT SENSE, REASON AND ACE FILES IN THEIR OWN WINDOW     
# VERSION:  no dragon-trace in zap-modules
# REMEMBER: you need to have ALL the latest xml-files created & scoped & zapped!
#    CHECK: use Studio4Xi to assist finding bugs!
# ---------------------------------------------------------------------------------------------
 
ZapKb4Xi = {
    800: {1: ace_all_methods4xi_zap2sphere,                          2: 'ack', 3: 'ace_all_methods4xi'},                # OK 
    801: {1: ace_ctypes4xi_zap2sphere,                               2: 'ack', 3: 'ace_ctypes4xi'},                     # OK 
    802: {1: ace_current_process4xi_zap2sphere,                      2: 'ack', 3: 'ace_current_process4xi'},            # OK 
    803: {1: ace_dummy_process4xi_zap2sphere,                        2: 'ack', 3: 'ace_dummy_process4xi'},              # OK 
    804: {1: ace_finalize4xi_zap2sphere,                             2: 'ack', 3: 'ace_finalize4xi'},                   # OK 
    805: {1: ace_hello_pipe4xi_zap2sphere,                           2: 'ack', 3: 'ace_hello_pipe4xi'},                 # OK 
    806: {1: ace_hello_world4xi_zap2sphere,                          2: 'ack', 3: 'ace_hello_world4xi'},                # OK 
    807: {1: ace_math4xi_zap2sphere,                                 2: 'ack', 3: 'ace_math4xi'},                       # OK 
    808: {1: ace_pickle4xi_zap2sphere,                               2: 'ack', 3: 'ace_pickle4xi'},                     # OK 
    809: {1: ace_pipe1_test4xi_zap2sphere,                           2: 'ack', 3: 'ace_pipe1_test4xi'},                 # OK 
    
    810: {1: ace_pool_one_4xi_zap2sphere,                            2: 'ack', 3: 'ace_pool_one_4xi'},                  # OK 
    811: {1: ace_processref4xi_zap2sphere,                           2: 'ack', 3: 'ace_processref4xi'},                 # OK 
    812: {1: ace_proxy_mp_test4xi_zap2sphere,                        2: 'ack', 3: 'ace_proxy_mp_test4xi'},              # OK 
    813: {1: ace_public_methods_test4xi_zap2sphere,                  2: 'ack', 3: 'ace_public_methods_test4xi'},        # OK 
    814: {1: ace_sync_manager_test4xi_zap2sphere,                    2: 'ack', 3: 'ace_sync_manager_test4xi'},          # OK 
    815: {1: ace_test_after_fork4xi_zap2sphere,                      2: 'ack', 3: 'ace_test_after_fork4xi'},            # OK 
    816: {1: ace_test_arena4xi_zap2sphere,                           2: 'ack', 3: 'ace_test_arena4xi'},                 # OK 
    817: {1: ace_test_constant_connection4xi_zap2sphere,             2: 'ack', 3: 'ace_test_constant_connection4xi'},   # OK 
    818: {1: ace_test_constant_family4xi_zap2sphere,                 2: 'ack', 3: 'ace_test_constant_family4xi'},       # OK 
    819: {1: ace_test_constant_forking4xi_zap2sphere,                2: 'ack', 3: 'ace_test_constant_forking4xi'},      # OK 
    
    820: {1: ace_test_constant_heap4xi_zap2sphere,                   2: 'ack', 3: 'ace_test_constant_heap4xi'},         # OK 
    821: {1: ace_test_constant_logger4xi_zap2sphere,                 2: 'ack', 3: 'ace_test_constant_logger4xi'},       # OK 
    822: {1: ace_test_constant_managers4xi_zap2sphere,               2: 'ack', 3: 'ace_test_constant_managers4xi'},     # OK 
    823: {1: ace_test_constant_pool4xi_zap2sphere,                   2: 'ack', 3: 'ace_test_constant_pool4xi'},         # OK 
    824: {1: ace_test_constant_process4xi_zap2sphere,                2: 'ack', 3: 'ace_test_constant_process4xi'},      # OK 
    825: {1: ace_test_constant_synchronize4xi_zap2sphere,            2: 'ack', 3: 'ace_test_constant_synchronize4xi'},  # OK 
    826: {1: ace_test_constant_system4xi_zap2sphere,                 2: 'ack', 3: 'ace_test_constant_system4xi'},       # OK 
    827: {1: ace_test_constant_util4xi_zap2sphere,                   2: 'ack', 3: 'ace_test_constant_util4xi'},         # OK 
    828: {1: ace_test_cpu_corecount4xi_zap2sphere,                   2: 'ack', 3: 'ace_test_cpu_corecount4xi'},         # OK 
    829: {1: ace_test_format4xi_zap2sphere,                          2: 'ack', 3: 'ace_test_format4xi'},                # OK 
    
    830: {1: ace_test_kskeleton4xi_zap2sphere,                       2: 'ack', 3: 'ace_test_kskeleton4xi'},             # OK 
    831: {1: ace_test_logger4xi_zap2sphere,                          2: 'ack', 3: 'ace_test_logger4xi'},                # OK 
    832: {1: ace_test_manager4xi_zap2sphere,                         2: 'ack', 3: 'ace_test_manager4xi'},               # OK 
    833: {1: ace_test_original_dir4xi_zap2sphere,                    2: 'ack', 3: 'ace_test_original_dir4xi'},          # OK 
    834: {1: ace_test_server4xi_zap2sphere,                          2: 'ack', 3: 'ace_test_server4xi'},                # OK 
    835: {1: ace_test_shared_ctypes4xi_zap2sphere,                   2: 'ack', 3: 'ace_test_shared_ctypes4xi'},         # OK 
    836: {1: ace_test_skeleton_print4xi_zap2sphere,                  2: 'ack', 3: 'ace_test_skeleton_print4xi'},        # OK 
    837: {1: ace_test_sphere4xi_zap2sphere,                          2: 'ack', 3: 'ace_test_sphere4xi'},                # OK 
    838: {1: ace_test_state4xi_zap2sphere,                           2: 'ack', 3: 'ace_test_state4xi'},                 # OK 
    839: {1: ace_test_uskeleton4xi_zap2sphere,                       2: 'ack', 3: 'ace_test_uskeleton4xi'},             # OK 
    
    840: {1: ace_test_yskeleton4xi_zap2sphere,                       2: 'ack', 3: 'ace_test_yskeleton4xi'},             # OK 
    841: {1: ace_test_zskeleton4xi_zap2sphere,                       2: 'ack', 3: 'ace_test_zskeleton4xi'},             # OK 
    842: {1: ace_value_proxy4xi_zap2sphere,                          2: 'ack', 3: 'ace_value_proxy4xi'},                # OK 
    843: {1: ace_value_test4xi_zap2sphere,                           2: 'ack', 3: 'ace_value_test4xi'},                 # OK 

    # -------------------------------------------------------------------------------------------------------------------------
    # REASON SPHERES                                 REMEMBER: 'nack' = IMPORT IT !                            
    # -------------------------------------------------------------------------------------------------------------------------
    400: {1: reason_all_methods4xi_zap2sphere,                       2: 'ack', 3: 'reason_all_methods4xi'},             # OK
    401: {1: reason_ctypes4xi_zap2sphere,                            2: 'ack', 3: 'reason_ctypes4xi'},                  # OK
    402: {1: reason_current_process4xi_zap2sphere,                   2: 'ack', 3: 'reason_current_process4xi'},         # OK
    403: {1: reason_dummy_process4xi_zap2sphere,                     2: 'ack', 3: 'reason_dummy_process4xi'},           # OK
    404: {1: reason_finalize4xi_zap2sphere,                          2: 'ack', 3: 'reason_finalize4xi'},                # OK
    405: {1: reason_hello_pipe4xi_zap2sphere,                        2: 'ack', 3: 'reason_hello_pipe4xi'},              # OK
    406: {1: reason_hello_world4xi_zap2sphere,                       2: 'ack', 3: 'reason_hello_world4xi'},             # OK
    407: {1: reason_math4xi_zap2sphere,                              2: 'ack', 3: 'reason_math4xi'},                    # OK
    408: {1: reason_pickle4xi_zap2sphere,                            2: 'ack', 3: 'reason_pickle4xi'},                  # OK
    409: {1: reason_pipe1_test4xi_zap2sphere,                        2: 'ack', 3: 'reason_pipe1_test4xi'},              # OK
    
    410: {1: reason_pool_one_4xi_zap2sphere,                         2: 'ack', 3: 'reason_pool_one_4xi'},               # OK
    411: {1: reason_processref4xi_zap2sphere,                        2: 'ack', 3: 'reason_processref4xi'},              # OK
    412: {1: reason_proxy_mp_test4xi_zap2sphere,                     2: 'ack', 3: 'reason_proxy_mp_test4xi'},           # OK
    413: {1: reason_public_methods_test4xi_zap2sphere,               2: 'ack', 3: 'reason_public_methods_test4xi'},     # OK
    414: {1: reason_sync_manager_test4xi_zap2sphere,                 2: 'ack', 3: 'reason_sync_manager_test4xi'},       # OK
    415: {1: reason_test_after_fork4xi_zap2sphere,                   2: 'ack', 3: 'reason_test_after_fork4xi'},         # OK
    416: {1: reason_test_arena4xi_zap2sphere,                        2: 'ack', 3: 'reason_test_arena4xi'},              # OK
    417: {1: reason_test_constant_connection4xi_zap2sphere,          2: 'ack', 3: 'reason_test_constant_connection4xi'},# OK
    418: {1: reason_test_constant_family4xi_zap2sphere,              2: 'ack', 3: 'reason_test_constant_family4xi'},    # OK
    419: {1: reason_test_constant_forking4xi_zap2sphere,             2: 'ack', 3: 'reason_test_constant_forking4xi'},   # OK
    
    420: {1: reason_test_constant_heap4xi_zap2sphere,                2: 'ack', 3: 'reason_test_constant_heap4xi'},      # OK
    421: {1: reason_test_constant_logger4xi_zap2sphere,              2: 'ack', 3: 'reason_test_constant_logger4xi'},    # OK
    422: {1: reason_test_constant_managers4xi_zap2sphere,            2: 'ack', 3: 'reason_test_constant_managers4xi'},  # OK
    423: {1: reason_test_constant_pool4xi_zap2sphere,                2: 'ack', 3: 'reason_test_constant_pool4xi'},      # OK
    424: {1: reason_test_constant_process4xi_zap2sphere,             2: 'ack', 3: 'reason_test_constant_process4xi'},   # OK
    425: {1: reason_test_constant_synchronize4xi_zap2sphere,         2: 'ack', 3: 'reason_test_constant_synchronize4xi'},# OK
    426: {1: reason_test_constant_system4xi_zap2sphere,              2: 'ack', 3: 'reason_test_constant_system4xi'},    # OK
    427: {1: reason_test_constant_util4xi_zap2sphere,                2: 'ack', 3: 'reason_test_constant_util4xi'},      # OK
    428: {1: reason_test_cpu_corecount4xi_zap2sphere,                2: 'ack', 3: 'reason_test_cpu_corecount4xi'},      # OK
    429: {1: reason_test_format4xi_zap2sphere,                       2: 'ack', 3: 'reason_test_format4xi'},             # OK
    
    430: {1: reason_test_kskeleton4xi_zap2sphere,                    2: 'ack', 3: 'reason_test_kskeleton4xi'},          # OK
    431: {1: reason_test_logger4xi_zap2sphere,                       2: 'ack', 3: 'reason_test_logger4xi'},             # OK
    432: {1: reason_test_manager4xi_zap2sphere,                      2: 'ack', 3: 'reason_test_manager4xi'},            # OK
    433: {1: reason_test_original_dir4xi_zap2sphere,                 2: 'ack', 3: 'reason_test_original_dir4xi'},       # OK
    434: {1: reason_test_server4xi_zap2sphere,                       2: 'ack', 3: 'reason_test_server4xi'},             # OK
    435: {1: reason_test_shared_ctypes4xi_zap2sphere,                2: 'ack', 3: 'reason_test_shared_ctypes4xi'},      # OK
    436: {1: reason_test_skeleton_print4xi_zap2sphere,               2: 'ack', 3: 'reason_test_skeleton_print4xi'},     # OK
    437: {1: reason_test_sphere4xi_zap2sphere,                       2: 'ack', 3: 'reason_test_sphere4xi'},             # OK
    438: {1: reason_test_state4xi_zap2sphere,                        2: 'ack', 3: 'reason_test_state4xi'},              # OK
    439: {1: reason_test_uskeleton4xi_zap2sphere,                    2: 'ack', 3: 'reason_test_uskeleton4xi'},          # OK
    
    440: {1: reason_test_yskeleton4xi_zap2sphere,                    2: 'ack', 3: 'reason_test_yskeleton4xi'},          # OK
    441: {1: reason_test_zskeleton4xi_zap2sphere,                    2: 'ack', 3: 'reason_test_zskeleton4xi'},          # OK
    442: {1: reason_value_proxy4xi_zap2sphere,                       2: 'ack', 3: 'reason_value_proxy4xi'},             # OK
    443: {1: reason_value_test4xi_zap2sphere,                        2: 'ack', 3: 'reason_value_test4xi'},              # OK
    
    # -------------------------------------------------------------------------------------------------------------------------
    # SENSE SPHERES                                                  REMEMBER: 'nack' = IMPORT IT !                             
    # -------------------------------------------------------------------------------------------------------------------------
    200: {1: sense_all_methods4xi_zap2sphere,                        2: 'ack', 3: 'sense_all_methods4xi'},              # OK
    201: {1: sense_ctypes4xi_zap2sphere,                             2: 'ack', 3: 'sense_ctypes4xi'},                   # OK
    202: {1: sense_current_process4xi_zap2sphere,                    2: 'ack', 3: 'sense_current_process4xi'},          # OK
    203: {1: sense_dummy_process4xi_zap2sphere,                      2: 'ack', 3: 'sense_dummy_process4xi'},            # OK
    204: {1: sense_finalize4xi_zap2sphere,                           2: 'ack', 3: 'sense_finalize4xi'},                 # OK
    205: {1: sense_hello_pipe4xi_zap2sphere,                         2: 'ack', 3: 'sense_hello_pipe4xi'},               # OK
    206: {1: sense_hello_world4xi_zap2sphere,                        2: 'ack', 3: 'sense_hello_world4xi'},              # OK
    207: {1: sense_math4xi_zap2sphere,                               2: 'ack', 3: 'sense_math4xi'},                     # OK
    208: {1: sense_pickle4xi_zap2sphere,                             2: 'ack', 3: 'sense_pickle4xi'},                   # OK
    209: {1: sense_pipe1_test4xi_zap2sphere,                         2: 'ack', 3: 'sense_pipe1_test4xi'},               # OK
    
    210: {1: sense_pool_one_4xi_zap2sphere,                          2: 'ack', 3: 'sense_pool_one_4xi'},                # OK
    211: {1: sense_processref4xi_zap2sphere,                         2: 'ack', 3: 'sense_processref4xi'},               # OK
    212: {1: sense_proxy_mp_test4xi_zap2sphere,                      2: 'ack', 3: 'sense_proxy_mp_test4xi'},            # OK
    213: {1: sense_public_methods_test4xi_zap2sphere,                2: 'ack', 3: 'sense_public_methods_test4xi'},      # OK
    214: {1: sense_sync_manager_test4xi_zap2sphere,                  2: 'ack', 3: 'sense_sync_manager_test4xi'},        # OK
    215: {1: sense_test_after_fork4xi_zap2sphere,                    2: 'ack', 3: 'sense_test_after_fork4xi'},          # OK
    216: {1: sense_test_arena4xi_zap2sphere,                         2: 'ack', 3: 'sense_test_arena4xi'},               # OK
    217: {1: sense_test_constant_connection4xi_zap2sphere,           2: 'ack', 3: 'sense_test_constant_connection4xi'}, # OK
    218: {1: sense_test_constant_family4xi_zap2sphere,               2: 'ack', 3: 'sense_test_constant_family4xi'},     # OK
    219: {1: sense_test_constant_forking4xi_zap2sphere,              2: 'ack', 3: 'sense_test_constant_forking4xi'},    # OK
    
    220: {1: sense_test_constant_heap4xi_zap2sphere,                 2: 'ack', 3: 'sense_test_constant_heap4xi'},       # OK
    221: {1: sense_test_constant_logger4xi_zap2sphere,               2: 'ack', 3: 'sense_test_constant_logger4xi'},     # OK
    222: {1: sense_test_constant_managers4xi_zap2sphere,             2: 'ack', 3: 'sense_test_constant_managers4xi'},   # OK
    223: {1: sense_test_constant_pool4xi_zap2sphere,                 2: 'ack', 3: 'sense_test_constant_pool4xi'},       # OK
    224: {1: sense_test_constant_process4xi_zap2sphere,              2: 'ack', 3: 'sense_test_constant_process4xi'},    # OK
    225: {1: sense_test_constant_synchronize4xi_zap2sphere,          2: 'ack', 3: 'sense_test_constant_synchronize4xi'},# OK
    226: {1: sense_test_constant_system4xi_zap2sphere,               2: 'ack', 3: 'sense_test_constant_system4xi'},     # OK
    227: {1: sense_test_constant_util4xi_zap2sphere,                 2: 'ack', 3: 'sense_test_constant_util4xi'},       # OK
    228: {1: sense_test_cpu_corecount4xi_zap2sphere,                 2: 'ack', 3: 'sense_test_cpu_corecount4xi'},       # OK
    229: {1: sense_test_format4xi_zap2sphere,                        2: 'ack', 3: 'sense_test_format4xi'},              # OK
    
    230: {1: sense_test_kskeleton4xi_zap2sphere,                     2: 'ack', 3: 'sense_test_kskeleton4xi'},           # OK
    231: {1: sense_test_logger4xi_zap2sphere,                        2: 'ack', 3: 'sense_test_logger4xi'},              # OK
    232: {1: sense_test_manager4xi_zap2sphere,                       2: 'ack', 3: 'sense_test_manager4xi'},             # OK
    233: {1: sense_test_original_dir4xi_zap2sphere,                  2: 'ack', 3: 'sense_test_original_dir4xi'},        # OK
    234: {1: sense_test_server4xi_zap2sphere,                        2: 'ack', 3: 'sense_test_server4xi'},              # OK
    235: {1: sense_test_shared_ctypes4xi_zap2sphere,                 2: 'ack', 3: 'sense_test_shared_ctypes4xi'},       # OK
    236: {1: sense_test_skeleton_print4xi_zap2sphere,                2: 'ack', 3: 'sense_test_skeleton_print4xi'},      # OK
    237: {1: sense_test_sphere4xi_zap2sphere,                        2: 'ack', 3: 'sense_test_sphere4xi'},              # OK
    238: {1: sense_test_state4xi_zap2sphere,                         2: 'ack', 3: 'sense_test_state4xi'},               # OK
    239: {1: sense_test_uskeleton4xi_zap2sphere,                     2: 'ack', 3: 'sense_test_uskeleton4xi'},           # OK
    
    240: {1: sense_test_yskeleton4xi_zap2sphere,                     2: 'ack', 3: 'sense_test_yskeleton4xi'},           # OK
    241: {1: sense_test_zskeleton4xi_zap2sphere,                     2: 'nack', 3: 'sense_test_zskeleton4xi'},           # OK <-- DEFAULT
    242: {1: sense_value_proxy4xi_zap2sphere,                        2: 'ack', 3: 'sense_value_proxy4xi'},              # OK
    243: {1: sense_value_test4xi_zap2sphere,                         2: 'ack', 3: 'sense_value_test4xi'}                # OK        
    }                         
 
       
        
#"
#"/>

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'Pipe4Xi': 'NACK4TRACE',
         'Popen4Xi': 'NACK4TRACE',
         'Process4Xi': 'NACK4TRACE'
        }                              
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    # 
    
#</function4xi>                  


 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print2trace4xi" usage = "
#   printing trace
#">                    
# -------------------------------------------------------------------------------------------------    
def print2trace4xi(t2xi):
    ack2debug= True
    
    path2xml4scope = 'e:\\scope4xi\\041721\\zap\\web\\xml\\'                                                        # XML PATH  
    if ack2debug is True:
        print("(Step 1A/33) OF PRINT_TRACE4XI - TRYING TO CREATE SENSE TRACE ", time4xi())                          # 
    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': path2xml4scope + 'sense-zapimport2ball4xi.xml',                                                # FULL PATH GIVEN !
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Zap2Actor4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Zap2Actor4Xi in Multiprocessing.</rdfs:comment>\n',
     'debug4xi': True}                                                                                              # DEBUG ON!
    try:  
        xml_trace_sense4xi(t2xi, context2sense)
        if ack2debug is True:
            print("(Step 1B/33) OF PRINT_TRACE4XI - CREATED SENSE TRACE ", time4xi())                               # 
    except:
        print("(Step 1Z/33) OF PRINT_TRACE4XI *** FAILED TO CREATE SENSE TRACE *** ", time4xi())

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  

    if ack2debug is True:
        print("(Step 2A/33) OF PRINT_TRACE4XI - TRYING TO CREATE REASON TRACE ", time4xi())                         #       
    context2reason = {
     'file_path4xi': path2xml4scope + 'reason-zapimport2ball4xi.xml',                                               # FULL PATH GIVEN !
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Zap2Actor4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Zap2Actor4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}                                                                                              # DEBUG ON!
    
    try:   
        xml_trace_reason4xi(t2xi, context2reason)
        if ack2debug is True:
            print("(Step 2B/33) OF PRINT_TRACE4XI - CREATED REASON TRACE ", time4xi())                              #  
    except:
        print("(Step 2Z/33) OF PRINT_TRACE4XI *** FAILED TO CREATE REASON TRACE *** ", time4xi())  
        
    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
    if ack2debug is True:
        print("(Step 3A/33) OF PRINT_TRACE4XI - TRYING TO CREATE ACE TRACE ", time4xi())                            #         
    context2ace = {
     'file_path4xi': path2xml4scope + 'ace-zapimport2ball4xi.xml',                                                  # FULL PATH GIVEN !
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Zap2Actor4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Zap2Actor4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}                                                                                              # DEBUG ON!   
    
    try: 
        xml_trace_ace4xi(t2xi, context2ace)
        if ack2debug is True:
            print("(Step 3B/33) OF PRINT_TRACE4XI - CREATED ACE TRACE ", time4xi())                                 #            
    except:
        print("(Step 3Z/33) OF PRINT_TRACE4XI *** FAILED TO CREATE ACE TRACE *** ", time4xi())  

    # -------------------------------------------------------------------------------------------------
    # end of print2trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
  
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "zapimport2ball4xi" usage = "
#   reads the selected zap module for scope 
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def zapimport2ball4xi():
    global ZapKb4Xi    
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:

        # ---------------------------------------------------------------------------------------------
        # (Step 1/33) - START                          
        # ---------------------------------------------------------------------------------------------    
        print("(Step 1E/33) OF ZAPIMPORT2BALL4XI:  TRYING TO EXPLORE POTENTIAL FILES TO IMPORT FOR SCOPE ")         # 
        
        len2kb= len(ZapKb4Xi)
        
        print("(Step 1F/33) OF ZAPIMPORT2BALL4XI: MAX NUMBER OF SCOPE-XML FILES TO BE CHECKED - LEN2KB: ", len2kb) 
        keys2kb = ZapKb4Xi.keys()                                                                                   # 123 
        
        # ---------------------------------------------------------------------------------------------
        # (Step 2/33) - KNOWLEDGEBASE 
        # --------------------------------------------------------------------------------------------- 
        for key2kb in sorted(keys2kb):                                          
            print("(Step 2A/33) OF ZAPIMPORT2BALL4XI: CHECKING KEY: ", key2kb)  
                
            if ZapKb4Xi[key2kb] [2] == 'nack':
                print("(Step 2B/33) OF ZAPIMPORT2BALL4XI: TRYING TO COMMAND TO IMPORT KEY: ", key2kb)               # 201 .... 239 
                # -------------------------------------------------------------------------------------
                # ZAP 
                # -------------------------------------------------------------------------------------             
                try:
                    
                    import2ball4xi(ZapKb4Xi[key2kb] [1], ZapKb4Xi[key2kb] [3])                                      # pass sphere and file name 
             
                    print("(Step 2C/33) OF ZAPIMPORT2BALL4XI: IMPORTED KEY : ", key2kb)                             # 239
                except:
                    print("(Step 2Z/33) OF ZAPIMPORT2BALL4XI *** FAILED TO IMPORT KEY : ", key2kb, " ZapKb4Xi[", key2kb, "][1]: ", ZapKb4Xi[key2kb] [1], " ZapKb4Xi[", key2kb, "][3]: ", ZapKb4Xi[key2kb] [3])
                       
            else:
                
                pass
      
        # ---------------------------------------------------------------------------------------------
        # (Step 33/33) - DONE                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 33/33) OF ZAPIMPORT2BALL4XI: DONE!', time4xi())
        print('=' *33)
    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace - whatever happened
        # ---------------------------------------------------------------------------------------------     
        print2trace4xi(t2xi)            
   
         
       
#</function4xi>
     

                   
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function for zapimport2ball4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():

    print('=' *33)
    print("(Step 1A/33) OF ZAPIMPORT2BALL4XI - TRYING TO IMPORT ZAP FILE FOR SCOPE4XI ", time4xi())                 
    print('=' *33)
    
    zapimport2ball4xi()    
    
    print('=' *33)
    print("(Step 1B/33) OF ZAPIMPORT2BALL4XI - IMPORTED ZAP FILE FOR SCOPE4XI ", time4xi())                     
    print('=' *33) 

                                       
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
    
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   zapimport2ball4xi.txt
#   zap-sense- xml files
#
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of zapimport2ball4xi.py                          
# ------------------------------------------------------------------------------------------------- 
#"
#/>
